#define _GOGO_C_
#include "../common.h"
#include "../global.h"

#if defined(WIN32) || defined(__linux__)
	#define USE_BSS
#endif

static void putAlign(void)
{
	printf( "\talign 32\n" );
}

static void putMember( const char *base, const char *name, int offset )
{
	printf( "%%define %s.%s\t\t%s+%d\n", base, name, base, offset );
}

#define OFFSET( base, x ) ( (int)&base.x - (int)&base )
#define putMem( base, x ) putMember( #base, #x, OFFSET( base, x ) )

int main( int argc, char *argv[] )
{
	int externFlag = 0;

	/* 蔲IvV(extern mode) */
	if( argc == 2 ) externFlag = 1;

	puts( "\t%include \"nasm.cfg\"" );
	if( !externFlag ){
		static const char nameTbl[][4] = { "RO", "RW" };
		static const int valSize[] = { sizeof(RO) / 4, sizeof(RW) / 4 };
		int i;
		/* global mode */

		printf( "\tglobaldef RO, RW\n" );
#ifdef USE_BSS
		printf( "\tbss_segment\n" );
		for( i = 0; i < 2; i++ ){
			putAlign();
			printf( "%s\tresd %d\n", nameTbl[i], valSize[i] );
		}
#else	/* USE_BSS */
		printf( "\tdata_segment\n" );
		for( i = 0; i < 2; i++ ){
			int size;
			size = valSize[i];
			putAlign();
			puts( nameTbl[i] );
			do{
				int j, remain;
				remain = ( size >= 16 ) ? 16 : size;
				printf( "\tdd " );
				for( j = 0; j < remain - 1; j++ ) printf( "0, " );
				printf( "0\n" );
				size -= remain;
			}while( size );
		}
#endif	/* USE_BSS */
		printf( "\tend\n" );
	}else{
		/* extern mode */
		printf( "\texterndef RO, RW\n" );
		/* sample code */
		putMem( RW, channels_out );
		putMem( RW, padding );
	}
	return 0;
}
