/*
 *	for GOGO-no-coda
 *	Copyright (C) 2001 gogo-developer
 */

#include "common.h"
#include "global.h"
#include "tool.h"
#include "gogo.h"
#include "lame.h"
#include "vbrtag.h"
#include "basic_io.h"

static FILE *infp;
static FILE *outfp;

void
initBasicIO( void )
{
	infp = outfp = NULL;
} /* initBasicIO */

int
openInputFile(char *fname)
{
	if(!strcmp(fname, "stdin")){
		infp = stdin;
		setBinaryMode(infp);
	}else{
		infp = fopen(fname, "rb");
		if(!infp) return ERR;
	}
	return NOERR;
} /* openInputFile */

void
closeInputFile(void)
{
	if( infp && infp != stdin) fclose(infp);
} /* closeInputFile */

int
openOutputFile(char *fname)
{
	outfp = fopen(fname, "wb+");
	if(!outfp) return ERR;
	return NOERR;
} /* openOutputFile */

void
closeOutputFile(void)
{
	if( outfp && outfp != stdout ) fclose(outfp);
} /* closeOutputFile */

size_t
readData(unsigned char *data, size_t size)
{
	if( RO.userIn.pUserFunc != MPGE_NULL_FUNC ){
		return	(RO.userIn.pUserFunc( data, size ) == ME_NOERR ) ? size : 0;
	}else{
		return fread(data, 1, size, infp);
	}
	return -1;
} /* readData */

size_t
writeData(unsigned char *data, size_t size)
{
	if( RO.userOut != MPGE_NULL_FUNC ){
		return	( RO.userOut(data, size ) == ME_NOERR ) ? size : 0;
	}else{
		return fwrite(data, 1, size, outfp);
	}
} /* writeData */

void
lame_mp3_tags_fid(void)
{
	if(RO.VBR){
		/* Map VBR_q to Xing quality value: 0=worst, 100=best */
		int nQuality = ((9-RO.VBR_q) * 100) / 9;

		/* Write Xing header again */
		if(!fseek(outfp, 0, SEEK_SET)) PutVbrTag(outfp, nQuality);
	}
} /* lame_mp3_tags_fid */

